//!CompilePal::IncludeDirectory("materials/vip_mobster")
//!CompilePal::IncludeDirectory("models/vip_mobster")
//!CompilePal::IncludeDirectory("sound/vip_mobster")
//!CompilePal::IncludeDirectory("sound/mvm/mobster_t1")
//!CompilePal::IncludeDirectory("scripts/vscripts/mashup_2025")

gamemode_name <- "mashup_2025";
//::useDebugReload <- true && !IsDedicatedServer();
::useDebugReload <- true;

function Mainload()
{
    IncludeIfNot("_charlib/custom_character.nut", "CustomCharacter" in ROOT);
    InitCustomCharacterSystem();

    IncludeIfNot("_charlib/custom_weapon.nut", "CustomWeaponBase" in ROOT);
    IncludeIfNot("_charlib/projectile.nut", "ProjectileInfo" in ROOT);
    IncludeIfNot("_charlib/projectile_test.nut", "ProjectileInfo" in ROOT);
    IncludeIfNot("vip/characters/vip_shared.nut", "VIPShared" in ROOT);
    IncludeIfNot("vip/characters/civilian/civilian_offhand_coin.nut", "AbilityOffhandCoin" in ROOT);
    IncludeIfNot("vip/characters/civilian/vip_civilian.nut", "VIPCivilian" in ROOT);
    IncludeIfNot("vip/characters/civilian/vip_julius.nut", "VIPJulius" in ROOT);
    Include("vip/characters/merc_changes/vip_merc.nut");

    IncludeIfNot("vip/characters/mobster/vip_mobster.nut", "VIOPMobster" in ROOT);
    Include("_charlib/vcd_replacer.nut");

    Include("vip/gamemode/vip_gamemode.nut");
}

IncludeScript(gamemode_name + "/__lizardcore/_core.nut");
try { IncludeScript.call(this, gamemode_name + "/__lizardcore/debug.nut"); } catch (e) { }

OnDevCommand("julius", function(player, args)
{
    ConvertToCustomCharacter(FindPlayerByArgs(player, args), VIPJulius);
});

OnDevCommand("mobster", function(player, args)
{
    ConvertToCustomCharacter(FindPlayerByArgs(player, args), VIPMobster);
});

OnDevCommand("test2", function(player, args)
{
    player.PlayScene("scenes/Player/Scout/low/380.vcd", 0.3)
});

OnDevCommand("test3", function(player, args)
{
    local point_clientcommand = SpawnEntityFromTable("point_clientcommand",
    {
        IsEnabled = true
    })
    point_clientcommand.AcceptInput("Command", "voicemenu 1 1", player, player);
    EntFireByHandle(point_clientcommand, "Kill", null, 1, null, null);
});

OnDevCommand("test4", function(player, args)
{
    local gun = player.GetActiveWeapon();
    local test;
    printl("a")
    BeginBenchmark()
    for (local i = 0; i < 10000; i++)
        player.GetActiveWeapon().GetClassname();
    printl(EndBenchmark())
    BeginBenchmark()
    for (local i = 0; i < 10000; i++)
        GetPropEntity(player.GetActiveWeapon(), "m_hHealingTarget");
    printl(EndBenchmark())
});


OnDevCommand("class", function(player, args)
{
    local myClass = VIP_CLASS_CHARACTERS[player.GetPlayerClass()];
    if (myClass)
        ConvertToCustomCharacter(player, myClass);
});

OnDevCommand("kill_glow", function(player, args)
{
    ClientPrint(player, 3, "Killing the Glow")

    foreach(k, v in GlowController.glowGontrollers)
        try { k.DestroyGlowController.call(k); } catch(e) { }
    GlowController.constructor <- function(glow_target)
    {
    }
});

OnDevCommand("respawn_cane", function(player, args)
{
    SpawnBlueCaneAt(args[0]);
});
